<template>
  <v-layout justify-space-between wrap class="feedback" :class="styleFeedback">
    <v-flex xs11 lg8 wrap>
      <score-animation :score="feedback.earnedPoints" :correct="feedback.correct"/>
      <feedback-info :open="open" :feedback="feedback"/>
    </v-flex>
    <v-flex xs1 v-if="$vuetify.breakpoint.mdAndDown">
      <feedback-toggle v-model="open"/>
    </v-flex>
    <v-flex lg4 row justify-space-between>
      <feedback-toggle v-if="$vuetify.breakpoint.lgAndUp" v-model="open"/>
      <v-layout
        wrap
        class="px-2"
        :justify-center="$vuetify.breakpoint.mdAndDown"
        :justify-end="$vuetify.breakpoint.lgAndUp"
      >
        <v-btn
          v-if="open && !feedback.correct"
          @click="retry"
          class="font-weight-bold default-btn default-btn__md feedback__button"
          outline
          color="white"
        >Retry</v-btn>
        <v-btn
          v-show="open"
          @click="feedbackContinue"
          class="font-weight-bold default-btn default-btn__md feedback__button"
          color="green"
        >Next</v-btn>
      </v-layout>
    </v-flex>
  </v-layout>
</template>

<script>
import FeedbackInfo from './components/FeedbackInfo';
import FeedbackToggle from './components/FeedbackToggle';
import ScoreAnimation from './components/ScoreAnimation';

export default {
  components: {
    FeedbackInfo,
    FeedbackToggle,
    ScoreAnimation,
  },
  data() {
    return {
      open: true,
    };
  },
  props: {
    feedback: {
      type: Object,
      default: () => ({}),
    },
  },
  methods: {
    commentAction() {
      this.$emit('comment');
    },
    reaction(data) {
      this.$emit('reaction', data);
    },
    feedbackContinue() {
      this.$emit('feedbackContinue');
    },
    retry() {
      this.$emit('retry');
    },
  },
  computed: {
    styleFeedback() {
      return {
        feedback__correct: this.feedback.correct,
        feedback__wrong: !this.feedback.correct,
        feedback__active: this.feedback.showFeedback,
        feedback__toggle: !this.open,
        'px-3': this.$vuetify.breakpoint.lgAndUp,
      };
    },
  },
};
</script>

<style lang="sass">
  @import ~@/styles/defaults/mobileFirst
  .feedback
    position: fixed
    user-select: none
    z-index: 199
    bottom: -100vh
    padding: 20px
    width: 100%
    color: #fff
    transition: 0.4s ease all
    &__button
      width: 100%
      max-width: 100%
      padding: 25px!important
      line-height: 0.2
    &__toggle
    padding: 10px 0px
    &__active
      bottom: 0px
    &__correct
      background: #4db6ac
    &__wrong
      background: #4c4c4c
    +media-min-lg()
      &__button
        max-width: 11em
        font-size: 16px!important
        text-transform: none!important
        padding: 28px 0px!important

</style>
